import java.sql.*;
import java.util.*;

public class Ex5
{
    Connection mainConnection = null;
    Statement mainStatement = null;
    PreparedStatement SecondStatement = null; 
    Statement ThirdStatement = null; 
    ResultSet mainResultSet = null;

    /*****************************/
    public static void main(String args[]) 
    {
        System.out.println();
	Ex5 e = new Ex5();
        System.out.println();
    }

    /*****************************/
    public Ex5()
    {
        ConnectToDB();			// connect to DB
	
    	PublishData();			// publish some data
	
	SearchAllTuples();		// search for all tuples

	ShowMetaData();			// show meta data

	ShowAllTuples();		// show results of the search

    	ShowSomeTuples();		// show some of the results of the search again
    }


    /*****************************/
    public void SearchAllTuples()
    {
	try
    	{
                                // searches for all tuples 
	        System.out.println(" ** Selecting all tuples in the table **" );
	        mainResultSet = mainStatement.executeQuery( "select * from info; " );	
	}
    	catch( Exception e )
	    { System.out.println( " Error : " + e.toString() ); }
    }

    /*****************************/
    public void ShowMetaData()
    {
    	try
	{
                                // shows meta data
    	        System.out.println("\n ** Obtaining Meta Data ** " );
	        ResultSetMetaData meta = mainResultSet.getMetaData();
	        for( int col=1; col<=meta.getColumnCount(); col++ )
		        System.out.println( "Column: " + meta.getColumnName(col) + "\t, Type: " + meta.getColumnTypeName(col) );	
    	}
	catch( Exception e )
    	{ System.out.println( " Error : " + e.toString() ); }
    }

    /*****************************/
    public void ShowAllTuples()
    {
    	try
	{
                                // shows result of the query
	        ResultSetMetaData meta = mainResultSet.getMetaData();

    	        System.out.println("\n ** Showing all Tuples ** " );
	        int tupleCount=1;
 	        while( mainResultSet.next() )
    	        {
	    	    System.out.print( "Tuple " + tupleCount++ + " : " );
    		    for( int col=1; col<=meta.getColumnCount(); col++)
	        	     System.out.print( "\""+mainResultSet.getString( col )+"\"," );
		        System.out.println();
       	        }
        }
	catch( Exception e )
	    { System.out.println(" Error : " + e.toString() ); }

	System.out.println();
    }

    /*****************************/
    public void ShowSomeTuples()
    {
    	try
	{
                                // shows some of the results of the query
	        mainResultSet = ThirdStatement.executeQuery( "select * from info; ");
    	        ResultSetMetaData meta = mainResultSet.getMetaData();

	        System.out.println("\n ** Showing some Tuples ** " );
	
    	        System.out.print("\nFirst Tuple: " );
 	        mainResultSet.next();
	        for( int col=1; col<=meta.getColumnCount(); col++)
		         System.out.print( "\""+mainResultSet.getString( col )+"\"," );	    

    	        System.out.print("\nNext Tuple: " );
 	        mainResultSet.next();
	        for( int col=1; col<=meta.getColumnCount(); col++)
		        System.out.print( "\""+mainResultSet.getString( col )+"\"," );
	    
    	        System.out.print("\nPrev. Tuple: " );
 	        mainResultSet.previous();
	        for( int col=1; col<=meta.getColumnCount(); col++)
		        System.out.print( "\""+mainResultSet.getString( col )+"\"," );  

    	        System.out.print("\n3rd Tuple: " );
 	        mainResultSet.absolute(3);
	        for( int col=1; col<=meta.getColumnCount(); col++)
		        System.out.print( "\""+mainResultSet.getString( col )+"\"," );  	

                System.out.print("\nThe last Tuple: " );
                mainResultSet.last();
                for( int col=1; col<=meta.getColumnCount(); col++)
                        System.out.print( "\""+mainResultSet.getString( col )+"\"," );		

	        System.out.println();      
	}
	catch( Exception e )
	{ System.out.println( "Exception : " + e.toString() ); }
    }
        
    /*****************************/
    public void ConnectToDB()
    {
	// loading Informix driver
    	try
	{
                                        // Loading the JDBC driver for informix
            System.out.print("Looking for Informix's jdbc-odbc driver ... ");
            Class.forName("com.informix.jdbc.IfxDriver");
            System.out.println("loaded.\n");
                        
             
                                        // specifies location of DB, connecting port
            String URL = "jdbc:informix-sqli://esfahaan.usc.edu:1425";
            
                                        // DB server name, your DB name, user name, password
            Properties p = new Properties();
            p.put("INFORMIXSERVER", "dimlab");
            p.put("database", "temp585");
            p.put("user", "temp585");
            p.put("password", "temp585");
    
                                        // connect to DB using the above parameters
            System.out.print( "Connecting to DB ..." );
            Connection mainConnection = DriverManager.getConnection(URL, p);
            System.out.println(" Connected" );
            
                                        // making two regular and one prepared statement
            mainStatement = mainConnection.createStatement();
            SecondStatement = mainConnection.prepareStatement( "insert into info values( ?, ?, ?);" );
            ThirdStatement = mainConnection.createStatement(
                                         ResultSet.TYPE_SCROLL_INSENSITIVE,
                                         ResultSet.CONCUR_READ_ONLY); 
        }
        catch( Exception e )
        { 
	    System.out.println( "Error connecting to DB: "+ e.toString() );
    	    System.exit(-1);
        }
    }

    /*****************************/
    public void PublishData()
    {
    	try
	{
                                // delete previous data from the DB
            System.out.print( " ** Deleting previous tuples ..." );
            mainStatement.executeUpdate( "delete from info;" );
            System.out.println( "Deleted. **" );
                                         
                                // publish new data
            System.out.print( " ** Inserting Data ..." );
    	    mainStatement.executeUpdate( "insert into info values ('Clinton,Bill', '9876543210', 400000);" );
	    mainStatement.executeUpdate( "insert into info values ('Doll, Bob', '1234567890', 100000);" );
	    mainStatement.executeUpdate( "insert into info values ('Bush, George', '6543210987', 450000);" );
    	    mainStatement.executeUpdate( "insert into info values ('Gore, Al','3210987654', 200000);" );
	    mainStatement.executeUpdate( "insert into info values ('Bing, Chandler', '4321056789', 750000);" );
	    System.out.println( "Done. **\n" );

	}
    	catch( Exception e )
	    { System.out.println( " Error 2: " + e.toString() ); }
    }


}


